<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd"><html xmlns="http://www.w3.org/1999/xhtml"><head><link rel="stylesheet" type="text/css" href="style.css" /><script type="text/javascript" src="highlight.js"></script></head><body><pre><span class="hs-keyword">module</span><span> </span><span class="hs-identifier">Morphology.Verbal</span><span> </span><span class="hs-special">(</span><span class="annot"><a href="Morphology.Verbal.html#inflectVerb"><span class="hs-identifier">inflectVerb</span></a></span><span class="hs-special">)</span><span> </span><span class="hs-keyword">where</span><span>
</span><span id="line-2"></span><span>
</span><span id="line-3"></span><span class="hs-keyword">import</span><span> </span><span class="annot"><span class="hs-identifier">Data.List</span></span><span>
</span><span id="line-4"></span><span class="hs-keyword">import</span><span> </span><span class="annot"><a href="EuskeraAppError.html"><span class="hs-identifier">EuskeraAppError</span></a></span><span>
</span><span id="line-5"></span><span class="hs-keyword">import</span><span> </span><span class="annot"><a href="Features.html"><span class="hs-identifier">Features</span></a></span><span>
</span><span id="line-6"></span><span class="hs-keyword">import</span><span> </span><span class="annot"><a href="Lexis.html"><span class="hs-identifier">Lexis</span></a></span><span>
</span><span id="line-7"></span><span class="hs-keyword">import</span><span> </span><span class="annot"><a href="Morphology.IrregularVerbs.html"><span class="hs-identifier">Morphology.IrregularVerbs</span></a></span><span>
</span><span id="line-8"></span><span class="hs-keyword">import</span><span> </span><span class="annot"><a href="Morphology.Utils.html"><span class="hs-identifier">Morphology.Utils</span></a></span><span>
</span><span id="line-9"></span><span>
</span><span id="line-10"></span><span class="annot"><a href="Morphology.Verbal.html#inflectVerb"><span class="hs-identifier hs-type">inflectVerb</span></a></span><span> </span><span class="hs-glyph">::</span><span> </span><span class="annot"><a href="Features.Verbal.html#VF"><span class="hs-identifier hs-type">VF</span></a></span><span> </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><a href="Lexis.Verb.html#Verb"><span class="hs-identifier hs-type">Verb</span></a></span><span> </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><span class="hs-identifier hs-type">Either</span></span><span> </span><span class="annot"><a href="EuskeraAppError.html#EuskeraAppError"><span class="hs-identifier hs-type">EuskeraAppError</span></a></span><span> </span><span class="annot"><a href="Morphology.Utils.html#InflectedWord"><span class="hs-identifier hs-type">InflectedWord</span></a></span><span>
</span><span id="line-11"></span><span id="inflectVerb"><span class="annot"><span class="annottext">inflectVerb :: VF -&gt; Verb -&gt; Either EuskeraAppError InflectedWord
</span><a href="Morphology.Verbal.html#inflectVerb"><span class="hs-identifier hs-var hs-var">inflectVerb</span></a></span></span><span> </span><span id="local-6989586621679082208"><span class="annot"><span class="annottext">VF
</span><a href="#local-6989586621679082208"><span class="hs-identifier hs-var">vf</span></a></span></span><span> </span><span id="local-6989586621679082207"><span class="annot"><span class="annottext">Verb
</span><a href="#local-6989586621679082207"><span class="hs-identifier hs-var">v</span></a></span></span><span>
</span><span id="line-12"></span><span>  </span><span class="hs-glyph">|</span><span> </span><span class="annot"><span class="annottext">Verb -&gt; InflectedWord
</span><a href="Lexis.Verb.html#getVerb"><span class="hs-identifier hs-var">getVerb</span></a></span><span> </span><span class="annot"><span class="annottext">Verb
</span><a href="#local-6989586621679082207"><span class="hs-identifier hs-var">v</span></a></span><span> </span><span class="annot"><span class="annottext">InflectedWord -&gt; InflectedWord -&gt; Bool
forall a. Eq a =&gt; a -&gt; a -&gt; Bool
</span><span class="hs-operator hs-var">==</span></span><span> </span><span class="annot"><span class="annottext">InflectedWord
</span><span class="hs-string">&quot;&quot;</span></span><span> </span><span class="hs-glyph">=</span><span> </span><span class="annot"><span class="annottext">EuskeraAppError -&gt; Either EuskeraAppError InflectedWord
forall a b. a -&gt; Either a b
</span><span class="hs-identifier hs-var">Left</span></span><span> </span><span class="annot"><span class="annottext">(EuskeraAppError -&gt; Either EuskeraAppError InflectedWord)
-&gt; EuskeraAppError -&gt; Either EuskeraAppError InflectedWord
forall a b. (a -&gt; b) -&gt; a -&gt; b
</span><span class="hs-operator hs-var">$</span></span><span> </span><span class="annot"><span class="annottext">InflectedWord -&gt; EuskeraAppError
</span><a href="EuskeraAppError.html#EmptyString"><span class="hs-identifier hs-var">EmptyString</span></a></span><span> </span><span class="annot"><span class="annottext">InflectedWord
</span><span class="hs-string">&quot;verb is empty&quot;</span></span><span>
</span><span id="line-13"></span><span>  </span><span class="hs-glyph">|</span><span> </span><span class="annot"><span class="annottext">VF -&gt; Instantiation
</span><a href="Features.Verbal.html#instantiation"><span class="hs-identifier hs-var hs-var">instantiation</span></a></span><span> </span><span class="annot"><span class="annottext">VF
</span><a href="#local-6989586621679082208"><span class="hs-identifier hs-var">vf</span></a></span><span> </span><span class="annot"><span class="annottext">Instantiation -&gt; Instantiation -&gt; Bool
forall a. Eq a =&gt; a -&gt; a -&gt; Bool
</span><span class="hs-operator hs-var">==</span></span><span> </span><span class="annot"><span class="annottext">Instantiation
</span><a href="Features.Verbal.html#Full"><span class="hs-identifier hs-var">Full</span></a></span><span> </span><span class="hs-glyph">=</span><span> </span><span class="annot"><span class="annottext">VF -&gt; Verb -&gt; Either EuskeraAppError InflectedWord
</span><a href="Morphology.Verbal.html#inflectFullVerb"><span class="hs-identifier hs-var">inflectFullVerb</span></a></span><span> </span><span class="annot"><span class="annottext">VF
</span><a href="#local-6989586621679082208"><span class="hs-identifier hs-var">vf</span></a></span><span> </span><span class="annot"><span class="annottext">Verb
</span><a href="#local-6989586621679082207"><span class="hs-identifier hs-var">v</span></a></span><span>
</span><span id="line-14"></span><span>  </span><span class="hs-glyph">|</span><span> </span><span class="annot"><span class="annottext">VF -&gt; Instantiation
</span><a href="Features.Verbal.html#instantiation"><span class="hs-identifier hs-var hs-var">instantiation</span></a></span><span> </span><span class="annot"><span class="annottext">VF
</span><a href="#local-6989586621679082208"><span class="hs-identifier hs-var">vf</span></a></span><span> </span><span class="annot"><span class="annottext">Instantiation -&gt; Instantiation -&gt; Bool
forall a. Eq a =&gt; a -&gt; a -&gt; Bool
</span><span class="hs-operator hs-var">==</span></span><span> </span><span class="annot"><span class="annottext">Instantiation
</span><a href="Features.Verbal.html#Main"><span class="hs-identifier hs-var">Main</span></a></span><span> </span><span class="hs-glyph">=</span><span> </span><span class="annot"><span class="annottext">VF -&gt; Verb -&gt; Either EuskeraAppError InflectedWord
</span><a href="Morphology.Verbal.html#inflectLexicalVerb"><span class="hs-identifier hs-var">inflectLexicalVerb</span></a></span><span> </span><span class="annot"><span class="annottext">VF
</span><a href="#local-6989586621679082208"><span class="hs-identifier hs-var">vf</span></a></span><span> </span><span class="annot"><span class="annottext">Verb
</span><a href="#local-6989586621679082207"><span class="hs-identifier hs-var">v</span></a></span><span>
</span><span id="line-15"></span><span>  </span><span class="hs-glyph">|</span><span> </span><span class="annot"><span class="annottext">VF -&gt; Instantiation
</span><a href="Features.Verbal.html#instantiation"><span class="hs-identifier hs-var hs-var">instantiation</span></a></span><span> </span><span class="annot"><span class="annottext">VF
</span><a href="#local-6989586621679082208"><span class="hs-identifier hs-var">vf</span></a></span><span> </span><span class="annot"><span class="annottext">Instantiation -&gt; Instantiation -&gt; Bool
forall a. Eq a =&gt; a -&gt; a -&gt; Bool
</span><span class="hs-operator hs-var">==</span></span><span> </span><span class="annot"><span class="annottext">Instantiation
</span><a href="Features.Verbal.html#AuxOrTrinko"><span class="hs-identifier hs-var">AuxOrTrinko</span></a></span><span> </span><span class="hs-glyph">=</span><span> </span><span class="annot"><span class="annottext">VF -&gt; Verb -&gt; Either EuskeraAppError InflectedWord
</span><a href="Morphology.Verbal.html#inflectAuxOrTrinko"><span class="hs-identifier hs-var">inflectAuxOrTrinko</span></a></span><span> </span><span class="annot"><span class="annottext">VF
</span><a href="#local-6989586621679082208"><span class="hs-identifier hs-var">vf</span></a></span><span> </span><span class="annot"><span class="annottext">Verb
</span><a href="#local-6989586621679082207"><span class="hs-identifier hs-var">v</span></a></span><span>
</span><span id="line-16"></span><span>
</span><span id="line-17"></span><span class="annot"><a href="Morphology.Verbal.html#inflectFullVerb"><span class="hs-identifier hs-type">inflectFullVerb</span></a></span><span class="hs-special">,</span><span>
</span><span id="line-18"></span><span>  </span><span class="annot"><a href="Morphology.Verbal.html#inflectLexicalVerb"><span class="hs-identifier hs-type">inflectLexicalVerb</span></a></span><span class="hs-special">,</span><span>
</span><span id="line-19"></span><span>  </span><span class="annot"><a href="Morphology.Verbal.html#inflectAuxOrTrinko"><span class="hs-identifier hs-type">inflectAuxOrTrinko</span></a></span><span> </span><span class="hs-glyph">::</span><span>
</span><span id="line-20"></span><span>    </span><span class="annot"><a href="Features.Verbal.html#VF"><span class="hs-identifier hs-type">VF</span></a></span><span> </span><span class="hs-glyph">-&gt;</span><span>
</span><span id="line-21"></span><span>    </span><span class="annot"><a href="Lexis.Verb.html#Verb"><span class="hs-identifier hs-type">Verb</span></a></span><span> </span><span class="hs-glyph">-&gt;</span><span>
</span><span id="line-22"></span><span>    </span><span class="annot"><span class="hs-identifier hs-type">Either</span></span><span> </span><span class="annot"><a href="EuskeraAppError.html#EuskeraAppError"><span class="hs-identifier hs-type">EuskeraAppError</span></a></span><span> </span><span class="annot"><a href="Morphology.Utils.html#InflectedWord"><span class="hs-identifier hs-type">InflectedWord</span></a></span><span>
</span><span id="line-23"></span><span id="inflectFullVerb"><span class="annot"><span class="annottext">inflectFullVerb :: VF -&gt; Verb -&gt; Either EuskeraAppError InflectedWord
</span><a href="Morphology.Verbal.html#inflectFullVerb"><span class="hs-identifier hs-var hs-var">inflectFullVerb</span></a></span></span><span> </span><span id="local-6989586621679082197"><span class="annot"><span class="annottext">VF
</span><a href="#local-6989586621679082197"><span class="hs-identifier hs-var">vf</span></a></span></span><span> </span><span id="local-6989586621679082196"><span class="annot"><span class="annottext">Verb
</span><a href="#local-6989586621679082196"><span class="hs-identifier hs-var">v</span></a></span></span><span>
</span><span id="line-24"></span><span>  </span><span class="hs-glyph">|</span><span> </span><span class="annot"><span class="annottext">VF -&gt; Aspect
</span><a href="Features.Verbal.html#aspect"><span class="hs-identifier hs-var hs-var">aspect</span></a></span><span> </span><span class="annot"><span class="annottext">VF
</span><a href="#local-6989586621679082197"><span class="hs-identifier hs-var">vf</span></a></span><span> </span><span class="annot"><span class="annottext">Aspect -&gt; Aspect -&gt; Bool
forall a. Eq a =&gt; a -&gt; a -&gt; Bool
</span><span class="hs-operator hs-var">==</span></span><span> </span><span class="annot"><span class="annottext">Aspect
</span><a href="Features.Verbal.html#Punctual"><span class="hs-identifier hs-var">Punctual</span></a></span><span> </span><span class="hs-glyph">=</span><span> </span><span class="annot"><span class="annottext">VF -&gt; Verb -&gt; Either EuskeraAppError InflectedWord
</span><a href="Morphology.Verbal.html#inflectIrregularVerbs"><span class="hs-identifier hs-var">inflectIrregularVerbs</span></a></span><span> </span><span class="annot"><span class="annottext">VF
</span><a href="#local-6989586621679082197"><span class="hs-identifier hs-var">vf</span></a></span><span> </span><span class="annot"><span class="annottext">Verb
</span><a href="#local-6989586621679082196"><span class="hs-identifier hs-var">v</span></a></span><span>
</span><span id="line-25"></span><span>  </span><span class="hs-glyph">|</span><span> </span><span class="annot"><span class="annottext">Bool
</span><span class="hs-identifier hs-var">otherwise</span></span><span> </span><span class="hs-glyph">=</span><span>
</span><span id="line-26"></span><span>    </span><span class="annot"><span class="annottext">[InflectedWord] -&gt; InflectedWord
</span><span class="hs-identifier hs-var">unwords</span></span><span>
</span><span id="line-27"></span><span>      </span><span class="annot"><span class="annottext">([InflectedWord] -&gt; InflectedWord)
-&gt; Either EuskeraAppError [InflectedWord]
-&gt; Either EuskeraAppError InflectedWord
forall (f :: * -&gt; *) a b. Functor f =&gt; (a -&gt; b) -&gt; f a -&gt; f b
</span><span class="hs-operator hs-var">&lt;$&gt;</span></span><span> </span><span class="annot"><span class="annottext">[Either EuskeraAppError InflectedWord]
-&gt; Either EuskeraAppError [InflectedWord]
forall (t :: * -&gt; *) (f :: * -&gt; *) a.
(Traversable t, Applicative f) =&gt;
t (f a) -&gt; f (t a)
</span><span class="hs-identifier hs-var">sequenceA</span></span><span>
</span><span id="line-28"></span><span>        </span><span class="hs-special">[</span><span> </span><span class="annot"><span class="annottext">Aspect -&gt; InflectedWord -&gt; Either EuskeraAppError InflectedWord
</span><a href="Morphology.Verbal.html#inflectAspect"><span class="hs-identifier hs-var">inflectAspect</span></a></span><span>
</span><span id="line-29"></span><span>            </span><span class="hs-special">(</span><span class="annot"><span class="annottext">VF -&gt; Aspect
</span><a href="Features.Verbal.html#aspect"><span class="hs-identifier hs-var hs-var">aspect</span></a></span><span> </span><span class="annot"><span class="annottext">VF
</span><a href="#local-6989586621679082197"><span class="hs-identifier hs-var">vf</span></a></span><span class="hs-special">)</span><span>
</span><span id="line-30"></span><span>            </span><span class="hs-special">(</span><span class="annot"><span class="annottext">Verb -&gt; InflectedWord
</span><a href="Lexis.Verb.html#getVerb"><span class="hs-identifier hs-var">getVerb</span></a></span><span> </span><span class="annot"><span class="annottext">Verb
</span><a href="#local-6989586621679082196"><span class="hs-identifier hs-var">v</span></a></span><span class="hs-special">)</span><span class="hs-special">,</span><span>
</span><span id="line-31"></span><span>          </span><span class="annot"><span class="annottext">VF -&gt; Verb -&gt; Either EuskeraAppError InflectedWord
</span><a href="Morphology.Verbal.html#chooseAux"><span class="hs-identifier hs-var">chooseAux</span></a></span><span> </span><span class="annot"><span class="annottext">VF
</span><a href="#local-6989586621679082197"><span class="hs-identifier hs-var">vf</span></a></span><span> </span><span class="annot"><span class="annottext">Verb
</span><a href="#local-6989586621679082196"><span class="hs-identifier hs-var">v</span></a></span><span>
</span><span id="line-32"></span><span>        </span><span class="hs-special">]</span><span>
</span><span id="line-33"></span><span id="inflectLexicalVerb"><span class="annot"><span class="annottext">inflectLexicalVerb :: VF -&gt; Verb -&gt; Either EuskeraAppError InflectedWord
</span><a href="Morphology.Verbal.html#inflectLexicalVerb"><span class="hs-identifier hs-var hs-var">inflectLexicalVerb</span></a></span></span><span> </span><span id="local-6989586621679082187"><span class="annot"><span class="annottext">VF
</span><a href="#local-6989586621679082187"><span class="hs-identifier hs-var">vf</span></a></span></span><span> </span><span id="local-6989586621679082186"><span class="annot"><span class="annottext">Verb
</span><a href="#local-6989586621679082186"><span class="hs-identifier hs-var">v</span></a></span></span><span>
</span><span id="line-34"></span><span>  </span><span class="hs-glyph">|</span><span> </span><span class="annot"><span class="annottext">VF -&gt; Aspect
</span><a href="Features.Verbal.html#aspect"><span class="hs-identifier hs-var hs-var">aspect</span></a></span><span> </span><span class="annot"><span class="annottext">VF
</span><a href="#local-6989586621679082187"><span class="hs-identifier hs-var">vf</span></a></span><span> </span><span class="annot"><span class="annottext">Aspect -&gt; Aspect -&gt; Bool
forall a. Eq a =&gt; a -&gt; a -&gt; Bool
</span><span class="hs-operator hs-var">==</span></span><span> </span><span class="annot"><span class="annottext">Aspect
</span><a href="Features.Verbal.html#Punctual"><span class="hs-identifier hs-var">Punctual</span></a></span><span> </span><span class="hs-glyph">=</span><span> </span><span class="annot"><span class="annottext">InflectedWord -&gt; Either EuskeraAppError InflectedWord
forall a b. b -&gt; Either a b
</span><span class="hs-identifier hs-var">Right</span></span><span> </span><span class="annot"><span class="annottext">InflectedWord
</span><span class="hs-string">&quot;&quot;</span></span><span>
</span><span id="line-35"></span><span>  </span><span class="hs-glyph">|</span><span> </span><span class="annot"><span class="annottext">Bool
</span><span class="hs-identifier hs-var">otherwise</span></span><span> </span><span class="hs-glyph">=</span><span> </span><span class="annot"><span class="annottext">Aspect -&gt; InflectedWord -&gt; Either EuskeraAppError InflectedWord
</span><a href="Morphology.Verbal.html#inflectAspect"><span class="hs-identifier hs-var">inflectAspect</span></a></span><span> </span><span class="hs-special">(</span><span class="annot"><span class="annottext">VF -&gt; Aspect
</span><a href="Features.Verbal.html#aspect"><span class="hs-identifier hs-var hs-var">aspect</span></a></span><span> </span><span class="annot"><span class="annottext">VF
</span><a href="#local-6989586621679082187"><span class="hs-identifier hs-var">vf</span></a></span><span class="hs-special">)</span><span> </span><span class="hs-special">(</span><span class="annot"><span class="annottext">Verb -&gt; InflectedWord
</span><a href="Lexis.Verb.html#getVerb"><span class="hs-identifier hs-var">getVerb</span></a></span><span> </span><span class="annot"><span class="annottext">Verb
</span><a href="#local-6989586621679082186"><span class="hs-identifier hs-var">v</span></a></span><span class="hs-special">)</span><span>
</span><span id="line-36"></span><span id="inflectAuxOrTrinko"><span class="annot"><span class="annottext">inflectAuxOrTrinko :: VF -&gt; Verb -&gt; Either EuskeraAppError InflectedWord
</span><a href="Morphology.Verbal.html#inflectAuxOrTrinko"><span class="hs-identifier hs-var hs-var">inflectAuxOrTrinko</span></a></span></span><span> </span><span id="local-6989586621679082185"><span class="annot"><span class="annottext">VF
</span><a href="#local-6989586621679082185"><span class="hs-identifier hs-var">vf</span></a></span></span><span> </span><span id="local-6989586621679082184"><span class="annot"><span class="annottext">Verb
</span><a href="#local-6989586621679082184"><span class="hs-identifier hs-var">v</span></a></span></span><span>
</span><span id="line-37"></span><span>  </span><span class="hs-glyph">|</span><span> </span><span class="annot"><span class="annottext">VF -&gt; Aspect
</span><a href="Features.Verbal.html#aspect"><span class="hs-identifier hs-var hs-var">aspect</span></a></span><span> </span><span class="annot"><span class="annottext">VF
</span><a href="#local-6989586621679082185"><span class="hs-identifier hs-var">vf</span></a></span><span> </span><span class="annot"><span class="annottext">Aspect -&gt; Aspect -&gt; Bool
forall a. Eq a =&gt; a -&gt; a -&gt; Bool
</span><span class="hs-operator hs-var">==</span></span><span> </span><span class="annot"><span class="annottext">Aspect
</span><a href="Features.Verbal.html#Punctual"><span class="hs-identifier hs-var">Punctual</span></a></span><span> </span><span class="hs-glyph">=</span><span> </span><span class="annot"><span class="annottext">VF -&gt; Verb -&gt; Either EuskeraAppError InflectedWord
</span><a href="Morphology.Verbal.html#inflectIrregularVerbs"><span class="hs-identifier hs-var">inflectIrregularVerbs</span></a></span><span> </span><span class="annot"><span class="annottext">VF
</span><a href="#local-6989586621679082185"><span class="hs-identifier hs-var">vf</span></a></span><span> </span><span class="annot"><span class="annottext">Verb
</span><a href="#local-6989586621679082184"><span class="hs-identifier hs-var">v</span></a></span><span>
</span><span id="line-38"></span><span>  </span><span class="hs-glyph">|</span><span> </span><span class="annot"><span class="annottext">Bool
</span><span class="hs-identifier hs-var">otherwise</span></span><span> </span><span class="hs-glyph">=</span><span> </span><span class="annot"><span class="annottext">VF -&gt; Verb -&gt; Either EuskeraAppError InflectedWord
</span><a href="Morphology.Verbal.html#chooseAux"><span class="hs-identifier hs-var">chooseAux</span></a></span><span> </span><span class="annot"><span class="annottext">VF
</span><a href="#local-6989586621679082185"><span class="hs-identifier hs-var">vf</span></a></span><span> </span><span class="annot"><span class="annottext">Verb
</span><a href="#local-6989586621679082184"><span class="hs-identifier hs-var">v</span></a></span><span>
</span><span id="line-39"></span><span>
</span><span id="line-40"></span><span class="hs-comment">--------------------------------------------------------------------------------</span><span>
</span><span id="line-41"></span><span class="hs-comment">-- Aspectual inflection</span><span>
</span><span id="line-42"></span><span class="hs-comment">--------------------------------------------------------------------------------</span><span>
</span><span id="line-43"></span><span class="annot"><a href="Morphology.Verbal.html#inflectAspect"><span class="hs-identifier hs-type">inflectAspect</span></a></span><span> </span><span class="hs-glyph">::</span><span> </span><span class="annot"><a href="Features.Verbal.html#Aspect"><span class="hs-identifier hs-type">Aspect</span></a></span><span> </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><a href="Morphology.Utils.html#Lexeme"><span class="hs-identifier hs-type">Lexeme</span></a></span><span> </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><span class="hs-identifier hs-type">Either</span></span><span> </span><span class="annot"><a href="EuskeraAppError.html#EuskeraAppError"><span class="hs-identifier hs-type">EuskeraAppError</span></a></span><span> </span><span class="annot"><a href="Morphology.Utils.html#InflectedWord"><span class="hs-identifier hs-type">InflectedWord</span></a></span><span>
</span><span id="line-44"></span><span id="inflectAspect"><span class="annot"><span class="annottext">inflectAspect :: Aspect -&gt; InflectedWord -&gt; Either EuskeraAppError InflectedWord
</span><a href="Morphology.Verbal.html#inflectAspect"><span class="hs-identifier hs-var hs-var">inflectAspect</span></a></span></span><span> </span><span class="annot"><span class="annottext">Aspect
</span><a href="Features.Verbal.html#Future"><span class="hs-identifier hs-var">Future</span></a></span><span> </span><span class="hs-glyph">=</span><span> </span><span class="annot"><span class="annottext">InflectedWord -&gt; Either EuskeraAppError InflectedWord
</span><a href="Morphology.Verbal.html#future"><span class="hs-identifier hs-var">future</span></a></span><span>
</span><span id="line-45"></span><span class="annot"><a href="Morphology.Verbal.html#inflectAspect"><span class="hs-identifier hs-var">inflectAspect</span></a></span><span> </span><span class="annot"><span class="annottext">Aspect
</span><a href="Features.Verbal.html#Imperfective"><span class="hs-identifier hs-var">Imperfective</span></a></span><span> </span><span class="hs-glyph">=</span><span> </span><span class="annot"><span class="annottext">InflectedWord -&gt; Either EuskeraAppError InflectedWord
</span><a href="Morphology.Verbal.html#imperfective"><span class="hs-identifier hs-var">imperfective</span></a></span><span>
</span><span id="line-46"></span><span class="annot"><a href="Morphology.Verbal.html#inflectAspect"><span class="hs-identifier hs-var">inflectAspect</span></a></span><span> </span><span class="annot"><span class="annottext">Aspect
</span><a href="Features.Verbal.html#Perfective"><span class="hs-identifier hs-var">Perfective</span></a></span><span> </span><span class="hs-glyph">=</span><span> </span><span class="annot"><span class="annottext">InflectedWord -&gt; Either EuskeraAppError InflectedWord
</span><a href="Morphology.Verbal.html#perfective"><span class="hs-identifier hs-var">perfective</span></a></span><span>
</span><span id="line-47"></span><span class="annot"><a href="Morphology.Verbal.html#inflectAspect"><span class="hs-identifier hs-var">inflectAspect</span></a></span><span> </span><span class="annot"><span class="annottext">Aspect
</span><span class="hs-identifier">_</span></span><span> </span><span class="hs-glyph">=</span><span>
</span><span id="line-48"></span><span>  </span><span class="hs-glyph">\</span><span id="local-6989586621679082176"><span class="annot"><span class="annottext">InflectedWord
</span><a href="#local-6989586621679082176"><span class="hs-identifier hs-var">x</span></a></span></span><span> </span><span class="hs-glyph">-&gt;</span><span>
</span><span id="line-49"></span><span>    </span><span class="annot"><span class="annottext">EuskeraAppError -&gt; Either EuskeraAppError InflectedWord
forall a b. a -&gt; Either a b
</span><span class="hs-identifier hs-var">Left</span></span><span> </span><span class="annot"><span class="annottext">(EuskeraAppError -&gt; Either EuskeraAppError InflectedWord)
-&gt; EuskeraAppError -&gt; Either EuskeraAppError InflectedWord
forall a b. (a -&gt; b) -&gt; a -&gt; b
</span><span class="hs-operator hs-var">$</span></span><span>
</span><span id="line-50"></span><span>      </span><span class="annot"><span class="annottext">InflectedWord -&gt; EuskeraAppError
</span><a href="EuskeraAppError.html#InflectionError"><span class="hs-identifier hs-var">InflectionError</span></a></span><span>
</span><span id="line-51"></span><span>        </span><span class="annot"><span class="annottext">InflectedWord
</span><span class="hs-string">&quot;inflectAspect expects Future, Imperfective or Perfective&quot;</span></span><span>
</span><span id="line-52"></span><span>
</span><span id="line-53"></span><span class="annot"><a href="Morphology.Verbal.html#future"><span class="hs-identifier hs-type">future</span></a></span><span> </span><span class="hs-glyph">::</span><span> </span><span class="annot"><a href="Morphology.Utils.html#Lexeme"><span class="hs-identifier hs-type">Lexeme</span></a></span><span> </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><span class="hs-identifier hs-type">Either</span></span><span> </span><span class="annot"><a href="EuskeraAppError.html#EuskeraAppError"><span class="hs-identifier hs-type">EuskeraAppError</span></a></span><span> </span><span class="annot"><a href="Morphology.Utils.html#InflectedWord"><span class="hs-identifier hs-type">InflectedWord</span></a></span><span>
</span><span id="line-54"></span><span id="future"><span class="annot"><span class="annottext">future :: InflectedWord -&gt; Either EuskeraAppError InflectedWord
</span><a href="Morphology.Verbal.html#future"><span class="hs-identifier hs-var hs-var">future</span></a></span></span><span> </span><span class="hs-glyph">=</span><span> </span><span class="annot"><span class="annottext">InflectedWord -&gt; Either EuskeraAppError InflectedWord
forall a b. b -&gt; Either a b
</span><span class="hs-identifier hs-var">Right</span></span><span> </span><span class="annot"><span class="annottext">(InflectedWord -&gt; Either EuskeraAppError InflectedWord)
-&gt; (InflectedWord -&gt; InflectedWord)
-&gt; InflectedWord
-&gt; Either EuskeraAppError InflectedWord
forall b c a. (b -&gt; c) -&gt; (a -&gt; b) -&gt; a -&gt; c
</span><span class="hs-operator hs-var">.</span></span><span> </span><span class="annot"><span class="annottext">(InflectedWord -&gt; InflectedWord)
-&gt; (InflectedWord -&gt; InflectedWord)
-&gt; InflectedWord
-&gt; InflectedWord
</span><a href="Morphology.Utils.html#ifEndsInVowel"><span class="hs-identifier hs-var">ifEndsInVowel</span></a></span><span> </span><span class="hs-special">(</span><span class="annot"><span class="annottext">InflectedWord -&gt; InflectedWord -&gt; InflectedWord
forall a. [a] -&gt; [a] -&gt; [a]
</span><span class="hs-operator hs-var">++</span></span><span> </span><span class="annot"><span class="annottext">InflectedWord
</span><span class="hs-string">&quot;ko&quot;</span></span><span class="hs-special">)</span><span> </span><span class="hs-special">(</span><span class="annot"><span class="annottext">InflectedWord -&gt; InflectedWord -&gt; InflectedWord
forall a. [a] -&gt; [a] -&gt; [a]
</span><span class="hs-operator hs-var">++</span></span><span> </span><span class="annot"><span class="annottext">InflectedWord
</span><span class="hs-string">&quot;go&quot;</span></span><span class="hs-special">)</span><span>
</span><span id="line-55"></span><span>
</span><span id="line-56"></span><span class="annot"><a href="Morphology.Verbal.html#imperfective"><span class="hs-identifier hs-type">imperfective</span></a></span><span> </span><span class="hs-glyph">::</span><span> </span><span class="annot"><a href="Morphology.Utils.html#Lexeme"><span class="hs-identifier hs-type">Lexeme</span></a></span><span> </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><span class="hs-identifier hs-type">Either</span></span><span> </span><span class="annot"><a href="EuskeraAppError.html#EuskeraAppError"><span class="hs-identifier hs-type">EuskeraAppError</span></a></span><span> </span><span class="annot"><a href="Morphology.Utils.html#InflectedWord"><span class="hs-identifier hs-type">InflectedWord</span></a></span><span>
</span><span id="line-57"></span><span id="imperfective"><span class="annot"><span class="annottext">imperfective :: InflectedWord -&gt; Either EuskeraAppError InflectedWord
</span><a href="Morphology.Verbal.html#imperfective"><span class="hs-identifier hs-var hs-var">imperfective</span></a></span></span><span> </span><span id="local-6989586621679082172"><span class="annot"><span class="annottext">InflectedWord
</span><a href="#local-6989586621679082172"><span class="hs-identifier hs-var">verb</span></a></span></span><span>
</span><span id="line-58"></span><span>  </span><span class="hs-glyph">|</span><span> </span><span class="annot"><span class="annottext">InflectedWord -&gt; Bool
</span><a href="#local-6989586621679082171"><span class="hs-identifier hs-var">endsIn</span></a></span><span> </span><span class="annot"><span class="annottext">InflectedWord
</span><span class="hs-string">&quot;tsi&quot;</span></span><span> </span><span class="hs-glyph">=</span><span> </span><span class="annot"><span class="annottext">InflectedWord -&gt; Either EuskeraAppError InflectedWord
forall a b. b -&gt; Either a b
</span><span class="hs-identifier hs-var">Right</span></span><span> </span><span class="annot"><span class="annottext">(InflectedWord -&gt; Either EuskeraAppError InflectedWord)
-&gt; InflectedWord -&gt; Either EuskeraAppError InflectedWord
forall a b. (a -&gt; b) -&gt; a -&gt; b
</span><span class="hs-operator hs-var">$</span></span><span> </span><span class="annot"><span class="annottext">InflectedWord
</span><a href="#local-6989586621679082170"><span class="hs-identifier hs-var">strip3</span></a></span><span> </span><span class="annot"><span class="annottext">InflectedWord -&gt; InflectedWord -&gt; InflectedWord
forall a. [a] -&gt; [a] -&gt; [a]
</span><span class="hs-operator hs-var">++</span></span><span> </span><span class="annot"><span class="annottext">InflectedWord
</span><span class="hs-string">&quot;sten&quot;</span></span><span>
</span><span id="line-59"></span><span>  </span><span class="hs-glyph">|</span><span> </span><span class="annot"><span class="annottext">InflectedWord -&gt; Bool
</span><a href="#local-6989586621679082171"><span class="hs-identifier hs-var">endsIn</span></a></span><span> </span><span class="annot"><span class="annottext">InflectedWord
</span><span class="hs-string">&quot;txi&quot;</span></span><span> </span><span class="hs-glyph">=</span><span> </span><span class="annot"><span class="annottext">InflectedWord -&gt; Either EuskeraAppError InflectedWord
forall a b. b -&gt; Either a b
</span><span class="hs-identifier hs-var">Right</span></span><span> </span><span class="annot"><span class="annottext">(InflectedWord -&gt; Either EuskeraAppError InflectedWord)
-&gt; InflectedWord -&gt; Either EuskeraAppError InflectedWord
forall a b. (a -&gt; b) -&gt; a -&gt; b
</span><span class="hs-operator hs-var">$</span></span><span> </span><span class="annot"><span class="annottext">InflectedWord
</span><a href="#local-6989586621679082170"><span class="hs-identifier hs-var">strip3</span></a></span><span> </span><span class="annot"><span class="annottext">InflectedWord -&gt; InflectedWord -&gt; InflectedWord
forall a. [a] -&gt; [a] -&gt; [a]
</span><span class="hs-operator hs-var">++</span></span><span> </span><span class="annot"><span class="annottext">InflectedWord
</span><span class="hs-string">&quot;xten&quot;</span></span><span>
</span><span id="line-60"></span><span>  </span><span class="hs-glyph">|</span><span> </span><span class="annot"><span class="annottext">InflectedWord -&gt; Bool
</span><a href="#local-6989586621679082171"><span class="hs-identifier hs-var">endsIn</span></a></span><span> </span><span class="annot"><span class="annottext">InflectedWord
</span><span class="hs-string">&quot;tzi&quot;</span></span><span> </span><span class="hs-glyph">=</span><span> </span><span class="annot"><span class="annottext">InflectedWord -&gt; Either EuskeraAppError InflectedWord
forall a b. b -&gt; Either a b
</span><span class="hs-identifier hs-var">Right</span></span><span> </span><span class="annot"><span class="annottext">(InflectedWord -&gt; Either EuskeraAppError InflectedWord)
-&gt; InflectedWord -&gt; Either EuskeraAppError InflectedWord
forall a b. (a -&gt; b) -&gt; a -&gt; b
</span><span class="hs-operator hs-var">$</span></span><span> </span><span class="annot"><span class="annottext">InflectedWord
</span><a href="#local-6989586621679082170"><span class="hs-identifier hs-var">strip3</span></a></span><span> </span><span class="annot"><span class="annottext">InflectedWord -&gt; InflectedWord -&gt; InflectedWord
forall a. [a] -&gt; [a] -&gt; [a]
</span><span class="hs-operator hs-var">++</span></span><span> </span><span class="annot"><span class="annottext">InflectedWord
</span><span class="hs-string">&quot;zten&quot;</span></span><span>
</span><span id="line-61"></span><span>  </span><span class="hs-glyph">|</span><span> </span><span class="annot"><span class="annottext">Bool
</span><a href="#local-6989586621679082169"><span class="hs-identifier hs-var">endsInTenEndings</span></a></span><span> </span><span class="hs-glyph">=</span><span> </span><span class="annot"><span class="annottext">InflectedWord -&gt; Either EuskeraAppError InflectedWord
forall a b. b -&gt; Either a b
</span><span class="hs-identifier hs-var">Right</span></span><span> </span><span class="annot"><span class="annottext">(InflectedWord -&gt; Either EuskeraAppError InflectedWord)
-&gt; InflectedWord -&gt; Either EuskeraAppError InflectedWord
forall a b. (a -&gt; b) -&gt; a -&gt; b
</span><span class="hs-operator hs-var">$</span></span><span> </span><span class="annot"><span class="annottext">InflectedWord
</span><a href="#local-6989586621679082168"><span class="hs-identifier hs-var">strip1</span></a></span><span> </span><span class="annot"><span class="annottext">InflectedWord -&gt; InflectedWord -&gt; InflectedWord
forall a. [a] -&gt; [a] -&gt; [a]
</span><span class="hs-operator hs-var">++</span></span><span> </span><span class="annot"><span class="annottext">InflectedWord
</span><span class="hs-string">&quot;ten&quot;</span></span><span>
</span><span id="line-62"></span><span>  </span><span class="hs-glyph">|</span><span> </span><span class="annot"><span class="annottext">InflectedWord -&gt; Bool
</span><a href="#local-6989586621679082171"><span class="hs-identifier hs-var">endsIn</span></a></span><span> </span><span class="annot"><span class="annottext">InflectedWord
</span><span class="hs-string">&quot;i&quot;</span></span><span> </span><span class="hs-glyph">=</span><span> </span><span class="annot"><span class="annottext">InflectedWord -&gt; Either EuskeraAppError InflectedWord
forall a b. b -&gt; Either a b
</span><span class="hs-identifier hs-var">Right</span></span><span> </span><span class="annot"><span class="annottext">(InflectedWord -&gt; Either EuskeraAppError InflectedWord)
-&gt; InflectedWord -&gt; Either EuskeraAppError InflectedWord
forall a b. (a -&gt; b) -&gt; a -&gt; b
</span><span class="hs-operator hs-var">$</span></span><span> </span><span class="annot"><span class="annottext">InflectedWord
</span><a href="#local-6989586621679082172"><span class="hs-identifier hs-var">verb</span></a></span><span> </span><span class="annot"><span class="annottext">InflectedWord -&gt; InflectedWord -&gt; InflectedWord
forall a. [a] -&gt; [a] -&gt; [a]
</span><span class="hs-operator hs-var">++</span></span><span> </span><span class="annot"><span class="annottext">InflectedWord
</span><span class="hs-string">&quot;tzen&quot;</span></span><span>
</span><span id="line-63"></span><span>  </span><span class="hs-glyph">|</span><span> </span><span class="annot"><span class="annottext">Bool
</span><a href="#local-6989586621679082167"><span class="hs-identifier hs-var">endsInTzenEndings</span></a></span><span> </span><span class="hs-glyph">=</span><span> </span><span class="annot"><span class="annottext">InflectedWord -&gt; Either EuskeraAppError InflectedWord
forall a b. b -&gt; Either a b
</span><span class="hs-identifier hs-var">Right</span></span><span> </span><span class="annot"><span class="annottext">(InflectedWord -&gt; Either EuskeraAppError InflectedWord)
-&gt; InflectedWord -&gt; Either EuskeraAppError InflectedWord
forall a b. (a -&gt; b) -&gt; a -&gt; b
</span><span class="hs-operator hs-var">$</span></span><span> </span><span class="annot"><span class="annottext">InflectedWord
</span><a href="#local-6989586621679082166"><span class="hs-identifier hs-var">strip2</span></a></span><span> </span><span class="annot"><span class="annottext">InflectedWord -&gt; InflectedWord -&gt; InflectedWord
forall a. [a] -&gt; [a] -&gt; [a]
</span><span class="hs-operator hs-var">++</span></span><span> </span><span class="annot"><span class="annottext">InflectedWord
</span><span class="hs-string">&quot;tzen&quot;</span></span><span>
</span><span id="line-64"></span><span>  </span><span class="hs-glyph">|</span><span> </span><span class="annot"><span class="annottext">Bool
</span><span class="hs-identifier hs-var">otherwise</span></span><span> </span><span class="hs-glyph">=</span><span> </span><span class="annot"><span class="annottext">EuskeraAppError -&gt; Either EuskeraAppError InflectedWord
forall a b. a -&gt; Either a b
</span><span class="hs-identifier hs-var">Left</span></span><span> </span><span class="annot"><span class="annottext">(EuskeraAppError -&gt; Either EuskeraAppError InflectedWord)
-&gt; EuskeraAppError -&gt; Either EuskeraAppError InflectedWord
forall a b. (a -&gt; b) -&gt; a -&gt; b
</span><span class="hs-operator hs-var">$</span></span><span> </span><span class="annot"><span class="annottext">InflectedWord -&gt; EuskeraAppError
</span><a href="EuskeraAppError.html#InflectionError"><span class="hs-identifier hs-var">InflectionError</span></a></span><span> </span><span class="annot"><span class="annottext">InflectedWord
</span><span class="hs-string">&quot;unknown verb ending&quot;</span></span><span>
</span><span id="line-65"></span><span>  </span><span class="hs-keyword">where</span><span>
</span><span id="line-66"></span><span>    </span><span id="local-6989586621679082171"><span class="annot"><span class="annottext">endsIn :: InflectedWord -&gt; Bool
</span><a href="#local-6989586621679082171"><span class="hs-identifier hs-var hs-var">endsIn</span></a></span></span><span> </span><span id="local-6989586621679082165"><span class="annot"><span class="annottext">InflectedWord
</span><a href="#local-6989586621679082165"><span class="hs-identifier hs-var">s</span></a></span></span><span> </span><span class="hs-glyph">=</span><span> </span><span class="annot"><span class="annottext">InflectedWord
</span><a href="#local-6989586621679082165"><span class="hs-identifier hs-var">s</span></a></span><span> </span><span class="annot"><span class="annottext">InflectedWord -&gt; InflectedWord -&gt; Bool
forall a. Eq a =&gt; [a] -&gt; [a] -&gt; Bool
</span><span class="hs-operator hs-var">`isSuffixOf`</span></span><span> </span><span class="annot"><span class="annottext">InflectedWord
</span><a href="#local-6989586621679082172"><span class="hs-identifier hs-var">verb</span></a></span><span>
</span><span id="line-67"></span><span>    </span><span id="local-6989586621679082169"><span class="annot"><span class="annottext">endsInTenEndings :: Bool
</span><a href="#local-6989586621679082169"><span class="hs-identifier hs-var hs-var">endsInTenEndings</span></a></span></span><span> </span><span class="hs-glyph">=</span><span> </span><span class="annot"><span class="annottext">[InflectedWord] -&gt; InflectedWord -&gt; Bool
</span><a href="Morphology.Utils.html#endsInSuffixes"><span class="hs-identifier hs-var">endsInSuffixes</span></a></span><span> </span><span class="hs-special">[</span><span class="annot"><span class="annottext">InflectedWord
</span><span class="hs-string">&quot;n&quot;</span></span><span class="hs-special">,</span><span> </span><span class="annot"><span class="annottext">InflectedWord
</span><span class="hs-string">&quot;si&quot;</span></span><span class="hs-special">,</span><span> </span><span class="annot"><span class="annottext">InflectedWord
</span><span class="hs-string">&quot;xi&quot;</span></span><span class="hs-special">,</span><span> </span><span class="annot"><span class="annottext">InflectedWord
</span><span class="hs-string">&quot;zi&quot;</span></span><span class="hs-special">]</span><span> </span><span class="annot"><span class="annottext">InflectedWord
</span><a href="#local-6989586621679082172"><span class="hs-identifier hs-var">verb</span></a></span><span>
</span><span id="line-68"></span><span>    </span><span id="local-6989586621679082167"><span class="annot"><span class="annottext">endsInTzenEndings :: Bool
</span><a href="#local-6989586621679082167"><span class="hs-identifier hs-var hs-var">endsInTzenEndings</span></a></span></span><span> </span><span class="hs-glyph">=</span><span> </span><span class="annot"><span class="annottext">[InflectedWord] -&gt; InflectedWord -&gt; Bool
</span><a href="Morphology.Utils.html#endsInSuffixes"><span class="hs-identifier hs-var">endsInSuffixes</span></a></span><span> </span><span class="hs-special">[</span><span class="annot"><span class="annottext">InflectedWord
</span><span class="hs-string">&quot;du&quot;</span></span><span class="hs-special">,</span><span> </span><span class="annot"><span class="annottext">InflectedWord
</span><span class="hs-string">&quot;tu&quot;</span></span><span class="hs-special">]</span><span> </span><span class="annot"><span class="annottext">InflectedWord
</span><a href="#local-6989586621679082172"><span class="hs-identifier hs-var">verb</span></a></span><span>
</span><span id="line-69"></span><span>    </span><span id="local-6989586621679082168"><span class="annot"><span class="annottext">strip1 :: InflectedWord
</span><a href="#local-6989586621679082168"><span class="hs-identifier hs-var hs-var">strip1</span></a></span></span><span> </span><span class="hs-glyph">=</span><span> </span><span class="annot"><span class="annottext">InflectedWord -&gt; InflectedWord
forall a. [a] -&gt; [a]
</span><span class="hs-identifier hs-var">init</span></span><span> </span><span class="annot"><span class="annottext">InflectedWord
</span><a href="#local-6989586621679082172"><span class="hs-identifier hs-var">verb</span></a></span><span>
</span><span id="line-70"></span><span>    </span><span id="local-6989586621679082166"><span class="annot"><span class="annottext">strip2 :: InflectedWord
</span><a href="#local-6989586621679082166"><span class="hs-identifier hs-var hs-var">strip2</span></a></span></span><span> </span><span class="hs-glyph">=</span><span> </span><span class="hs-special">(</span><span class="annot"><span class="annottext">InflectedWord -&gt; InflectedWord
forall a. [a] -&gt; [a]
</span><span class="hs-identifier hs-var">init</span></span><span> </span><span class="annot"><span class="annottext">(InflectedWord -&gt; InflectedWord)
-&gt; (InflectedWord -&gt; InflectedWord)
-&gt; InflectedWord
-&gt; InflectedWord
forall b c a. (b -&gt; c) -&gt; (a -&gt; b) -&gt; a -&gt; c
</span><span class="hs-operator hs-var">.</span></span><span> </span><span class="annot"><span class="annottext">InflectedWord -&gt; InflectedWord
forall a. [a] -&gt; [a]
</span><span class="hs-identifier hs-var">init</span></span><span class="hs-special">)</span><span> </span><span class="annot"><span class="annottext">InflectedWord
</span><a href="#local-6989586621679082172"><span class="hs-identifier hs-var">verb</span></a></span><span>
</span><span id="line-71"></span><span>    </span><span id="local-6989586621679082170"><span class="annot"><span class="annottext">strip3 :: InflectedWord
</span><a href="#local-6989586621679082170"><span class="hs-identifier hs-var hs-var">strip3</span></a></span></span><span> </span><span class="hs-glyph">=</span><span> </span><span class="hs-special">(</span><span class="annot"><span class="annottext">InflectedWord -&gt; InflectedWord
forall a. [a] -&gt; [a]
</span><span class="hs-identifier hs-var">init</span></span><span> </span><span class="annot"><span class="annottext">(InflectedWord -&gt; InflectedWord)
-&gt; (InflectedWord -&gt; InflectedWord)
-&gt; InflectedWord
-&gt; InflectedWord
forall b c a. (b -&gt; c) -&gt; (a -&gt; b) -&gt; a -&gt; c
</span><span class="hs-operator hs-var">.</span></span><span> </span><span class="annot"><span class="annottext">InflectedWord -&gt; InflectedWord
forall a. [a] -&gt; [a]
</span><span class="hs-identifier hs-var">init</span></span><span> </span><span class="annot"><span class="annottext">(InflectedWord -&gt; InflectedWord)
-&gt; (InflectedWord -&gt; InflectedWord)
-&gt; InflectedWord
-&gt; InflectedWord
forall b c a. (b -&gt; c) -&gt; (a -&gt; b) -&gt; a -&gt; c
</span><span class="hs-operator hs-var">.</span></span><span> </span><span class="annot"><span class="annottext">InflectedWord -&gt; InflectedWord
forall a. [a] -&gt; [a]
</span><span class="hs-identifier hs-var">init</span></span><span class="hs-special">)</span><span> </span><span class="annot"><span class="annottext">InflectedWord
</span><a href="#local-6989586621679082172"><span class="hs-identifier hs-var">verb</span></a></span><span>
</span><span id="line-72"></span><span>
</span><span id="line-73"></span><span class="annot"><a href="Morphology.Verbal.html#perfective"><span class="hs-identifier hs-type">perfective</span></a></span><span> </span><span class="hs-glyph">::</span><span> </span><span class="annot"><a href="Morphology.Utils.html#Lexeme"><span class="hs-identifier hs-type">Lexeme</span></a></span><span> </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><span class="hs-identifier hs-type">Either</span></span><span> </span><span class="annot"><a href="EuskeraAppError.html#EuskeraAppError"><span class="hs-identifier hs-type">EuskeraAppError</span></a></span><span> </span><span class="annot"><a href="Morphology.Utils.html#InflectedWord"><span class="hs-identifier hs-type">InflectedWord</span></a></span><span>
</span><span id="line-74"></span><span id="perfective"><span class="annot"><span class="annottext">perfective :: InflectedWord -&gt; Either EuskeraAppError InflectedWord
</span><a href="Morphology.Verbal.html#perfective"><span class="hs-identifier hs-var hs-var">perfective</span></a></span></span><span> </span><span class="hs-glyph">=</span><span> </span><span class="annot"><span class="annottext">InflectedWord -&gt; Either EuskeraAppError InflectedWord
forall a b. b -&gt; Either a b
</span><span class="hs-identifier hs-var">Right</span></span><span>
</span><span id="line-75"></span><span>
</span><span id="line-76"></span><span class="hs-comment">--------------------------------------------------------------------------------</span><span>
</span><span id="line-77"></span><span class="hs-comment">-- Auxiliary verb inflection</span><span>
</span><span id="line-78"></span><span class="hs-comment">--------------------------------------------------------------------------------</span><span>
</span><span id="line-79"></span><span>
</span><span id="line-80"></span><span class="annot"><a href="Morphology.Verbal.html#chooseAux"><span class="hs-identifier hs-type">chooseAux</span></a></span><span> </span><span class="hs-glyph">::</span><span> </span><span class="annot"><a href="Features.Verbal.html#VF"><span class="hs-identifier hs-type">VF</span></a></span><span> </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><a href="Lexis.Verb.html#Verb"><span class="hs-identifier hs-type">Verb</span></a></span><span> </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><span class="hs-identifier hs-type">Either</span></span><span> </span><span class="annot"><a href="EuskeraAppError.html#EuskeraAppError"><span class="hs-identifier hs-type">EuskeraAppError</span></a></span><span> </span><span class="annot"><a href="Morphology.Utils.html#InflectedWord"><span class="hs-identifier hs-type">InflectedWord</span></a></span><span>
</span><span id="line-81"></span><span id="chooseAux"><span class="annot"><span class="annottext">chooseAux :: VF -&gt; Verb -&gt; Either EuskeraAppError InflectedWord
</span><a href="Morphology.Verbal.html#chooseAux"><span class="hs-identifier hs-var hs-var">chooseAux</span></a></span></span><span> </span><span id="local-6989586621679082161"><span class="annot"><span class="annottext">VF
</span><a href="#local-6989586621679082161"><span class="hs-identifier hs-var">vf</span></a></span></span><span> </span><span class="hs-special">(</span><span class="annot"><a href="Lexis.Verb.html#Nor"><span class="hs-identifier hs-type">Nor</span></a></span><span> </span><span class="annot"><span class="annottext">InflectedWord
</span><span class="hs-identifier">_</span></span><span class="hs-special">)</span><span> </span><span class="hs-glyph">=</span><span> </span><span class="annot"><span class="annottext">Tense -&gt; NF -&gt; Either EuskeraAppError InflectedWord
</span><a href="Morphology.Verbal.html#norAux"><span class="hs-identifier hs-var">norAux</span></a></span><span> </span><span class="hs-special">(</span><span class="annot"><span class="annottext">VF -&gt; Tense
</span><a href="Features.Verbal.html#tense"><span class="hs-identifier hs-var hs-var">tense</span></a></span><span> </span><span class="annot"><span class="annottext">VF
</span><a href="#local-6989586621679082161"><span class="hs-identifier hs-var">vf</span></a></span><span class="hs-special">)</span><span> </span><span class="hs-special">(</span><span class="annot"><span class="annottext">VF -&gt; NF
</span><a href="Features.Verbal.html#nor"><span class="hs-identifier hs-var hs-var">nor</span></a></span><span> </span><span class="annot"><span class="annottext">VF
</span><a href="#local-6989586621679082161"><span class="hs-identifier hs-var">vf</span></a></span><span class="hs-special">)</span><span>
</span><span id="line-82"></span><span class="annot"><a href="Morphology.Verbal.html#chooseAux"><span class="hs-identifier hs-var">chooseAux</span></a></span><span> </span><span id="local-6989586621679082156"><span class="annot"><span class="annottext">VF
</span><a href="#local-6989586621679082156"><span class="hs-identifier hs-var">vf</span></a></span></span><span> </span><span class="hs-special">(</span><span class="annot"><a href="Lexis.Verb.html#Copula"><span class="hs-identifier hs-type">Copula</span></a></span><span> </span><span class="annot"><span class="annottext">InflectedWord
</span><span class="hs-identifier">_</span></span><span class="hs-special">)</span><span> </span><span class="hs-glyph">=</span><span> </span><span class="annot"><span class="annottext">Tense -&gt; NF -&gt; Either EuskeraAppError InflectedWord
</span><a href="Morphology.Verbal.html#norAux"><span class="hs-identifier hs-var">norAux</span></a></span><span> </span><span class="hs-special">(</span><span class="annot"><span class="annottext">VF -&gt; Tense
</span><a href="Features.Verbal.html#tense"><span class="hs-identifier hs-var hs-var">tense</span></a></span><span> </span><span class="annot"><span class="annottext">VF
</span><a href="#local-6989586621679082156"><span class="hs-identifier hs-var">vf</span></a></span><span class="hs-special">)</span><span> </span><span class="hs-special">(</span><span class="annot"><span class="annottext">VF -&gt; NF
</span><a href="Features.Verbal.html#nor"><span class="hs-identifier hs-var hs-var">nor</span></a></span><span> </span><span class="annot"><span class="annottext">VF
</span><a href="#local-6989586621679082156"><span class="hs-identifier hs-var">vf</span></a></span><span class="hs-special">)</span><span>
</span><span id="line-83"></span><span class="annot"><a href="Morphology.Verbal.html#chooseAux"><span class="hs-identifier hs-var">chooseAux</span></a></span><span> </span><span id="local-6989586621679082154"><span class="annot"><span class="annottext">VF
</span><a href="#local-6989586621679082154"><span class="hs-identifier hs-var">vf</span></a></span></span><span> </span><span class="hs-special">(</span><span class="annot"><a href="Lexis.Verb.html#NorNork"><span class="hs-identifier hs-type">NorNork</span></a></span><span> </span><span class="annot"><span class="annottext">InflectedWord
</span><span class="hs-identifier">_</span></span><span class="hs-special">)</span><span> </span><span class="hs-glyph">=</span><span> </span><span class="annot"><span class="annottext">Tense -&gt; NF -&gt; NF -&gt; Either EuskeraAppError InflectedWord
</span><a href="Morphology.Verbal.html#norNorkAux"><span class="hs-identifier hs-var">norNorkAux</span></a></span><span> </span><span class="hs-special">(</span><span class="annot"><span class="annottext">VF -&gt; Tense
</span><a href="Features.Verbal.html#tense"><span class="hs-identifier hs-var hs-var">tense</span></a></span><span> </span><span class="annot"><span class="annottext">VF
</span><a href="#local-6989586621679082154"><span class="hs-identifier hs-var">vf</span></a></span><span class="hs-special">)</span><span> </span><span class="hs-special">(</span><span class="annot"><span class="annottext">VF -&gt; NF
</span><a href="Features.Verbal.html#nork"><span class="hs-identifier hs-var hs-var">nork</span></a></span><span> </span><span class="annot"><span class="annottext">VF
</span><a href="#local-6989586621679082154"><span class="hs-identifier hs-var">vf</span></a></span><span class="hs-special">)</span><span> </span><span class="hs-special">(</span><span class="annot"><span class="annottext">VF -&gt; NF
</span><a href="Features.Verbal.html#nor"><span class="hs-identifier hs-var hs-var">nor</span></a></span><span> </span><span class="annot"><span class="annottext">VF
</span><a href="#local-6989586621679082154"><span class="hs-identifier hs-var">vf</span></a></span><span class="hs-special">)</span><span>
</span><span id="line-84"></span><span class="annot"><a href="Morphology.Verbal.html#chooseAux"><span class="hs-identifier hs-var">chooseAux</span></a></span><span> </span><span class="annot"><span class="annottext">VF
</span><span class="hs-identifier">_</span></span><span> </span><span class="annot"><span class="annottext">Verb
</span><span class="hs-identifier">_</span></span><span> </span><span class="hs-glyph">=</span><span> </span><span class="annot"><span class="annottext">EuskeraAppError -&gt; Either EuskeraAppError InflectedWord
forall a b. a -&gt; Either a b
</span><span class="hs-identifier hs-var">Left</span></span><span> </span><span class="annot"><span class="annottext">EuskeraAppError
</span><a href="EuskeraAppError.html#Unimplemented"><span class="hs-identifier hs-var">Unimplemented</span></a></span><span>
</span><span id="line-85"></span><span>
</span><span id="line-86"></span><span class="annot"><a href="Morphology.Verbal.html#norAux"><span class="hs-identifier hs-type">norAux</span></a></span><span> </span><span class="hs-glyph">::</span><span> </span><span class="annot"><a href="Features.Verbal.html#Tense"><span class="hs-identifier hs-type">Tense</span></a></span><span> </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><a href="Features.Nominal.html#NF"><span class="hs-identifier hs-type">NF</span></a></span><span> </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><span class="hs-identifier hs-type">Either</span></span><span> </span><span class="annot"><a href="EuskeraAppError.html#EuskeraAppError"><span class="hs-identifier hs-type">EuskeraAppError</span></a></span><span> </span><span class="annot"><a href="Morphology.Utils.html#InflectedWord"><span class="hs-identifier hs-type">InflectedWord</span></a></span><span>
</span><span id="line-87"></span><span id="norAux"><span class="annot"><span class="annottext">norAux :: Tense -&gt; NF -&gt; Either EuskeraAppError InflectedWord
</span><a href="Morphology.Verbal.html#norAux"><span class="hs-identifier hs-var hs-var">norAux</span></a></span></span><span> </span><span class="annot"><span class="annottext">Tense
</span><a href="Features.Verbal.html#Present"><span class="hs-identifier hs-var">Present</span></a></span><span> </span><span id="local-6989586621679082148"><span class="annot"><span class="annottext">NF
</span><a href="#local-6989586621679082148"><span class="hs-identifier hs-var">nf</span></a></span></span><span> </span><span class="hs-glyph">=</span><span> </span><span class="annot"><span class="annottext">InflectedWord -&gt; Either EuskeraAppError InflectedWord
forall a b. b -&gt; Either a b
</span><span class="hs-identifier hs-var">Right</span></span><span> </span><span class="annot"><span class="annottext">(InflectedWord -&gt; Either EuskeraAppError InflectedWord)
-&gt; InflectedWord -&gt; Either EuskeraAppError InflectedWord
forall a b. (a -&gt; b) -&gt; a -&gt; b
</span><span class="hs-operator hs-var">$</span></span><span> </span><span class="annot"><span class="annottext">Person -&gt; Number -&gt; InflectedWord
</span><a href="Morphology.IrregularVerbs.html#izanPresent"><span class="hs-identifier hs-var">izanPresent</span></a></span><span> </span><span class="hs-special">(</span><span class="annot"><span class="annottext">NF -&gt; Person
</span><a href="Features.Nominal.html#person"><span class="hs-identifier hs-var hs-var">person</span></a></span><span> </span><span class="annot"><span class="annottext">NF
</span><a href="#local-6989586621679082148"><span class="hs-identifier hs-var">nf</span></a></span><span class="hs-special">)</span><span> </span><span class="hs-special">(</span><span class="annot"><span class="annottext">NF -&gt; Number
</span><a href="Features.Nominal.html#number"><span class="hs-identifier hs-var hs-var">number</span></a></span><span> </span><span class="annot"><span class="annottext">NF
</span><a href="#local-6989586621679082148"><span class="hs-identifier hs-var">nf</span></a></span><span class="hs-special">)</span><span>
</span><span id="line-88"></span><span class="annot"><a href="Morphology.Verbal.html#norAux"><span class="hs-identifier hs-var">norAux</span></a></span><span> </span><span class="annot"><span class="annottext">Tense
</span><a href="Features.Verbal.html#Past"><span class="hs-identifier hs-var">Past</span></a></span><span> </span><span id="local-6989586621679082143"><span class="annot"><span class="annottext">NF
</span><a href="#local-6989586621679082143"><span class="hs-identifier hs-var">nf</span></a></span></span><span> </span><span class="hs-glyph">=</span><span> </span><span class="annot"><span class="annottext">InflectedWord -&gt; Either EuskeraAppError InflectedWord
forall a b. b -&gt; Either a b
</span><span class="hs-identifier hs-var">Right</span></span><span> </span><span class="annot"><span class="annottext">(InflectedWord -&gt; Either EuskeraAppError InflectedWord)
-&gt; InflectedWord -&gt; Either EuskeraAppError InflectedWord
forall a b. (a -&gt; b) -&gt; a -&gt; b
</span><span class="hs-operator hs-var">$</span></span><span> </span><span class="annot"><span class="annottext">Person -&gt; Number -&gt; InflectedWord
</span><a href="Morphology.IrregularVerbs.html#izanPast"><span class="hs-identifier hs-var">izanPast</span></a></span><span> </span><span class="hs-special">(</span><span class="annot"><span class="annottext">NF -&gt; Person
</span><a href="Features.Nominal.html#person"><span class="hs-identifier hs-var hs-var">person</span></a></span><span> </span><span class="annot"><span class="annottext">NF
</span><a href="#local-6989586621679082143"><span class="hs-identifier hs-var">nf</span></a></span><span class="hs-special">)</span><span> </span><span class="hs-special">(</span><span class="annot"><span class="annottext">NF -&gt; Number
</span><a href="Features.Nominal.html#number"><span class="hs-identifier hs-var hs-var">number</span></a></span><span> </span><span class="annot"><span class="annottext">NF
</span><a href="#local-6989586621679082143"><span class="hs-identifier hs-var">nf</span></a></span><span class="hs-special">)</span><span>
</span><span id="line-89"></span><span>
</span><span id="line-90"></span><span class="annot"><a href="Morphology.Verbal.html#norNorkAux"><span class="hs-identifier hs-type">norNorkAux</span></a></span><span> </span><span class="hs-glyph">::</span><span> </span><span class="annot"><a href="Features.Verbal.html#Tense"><span class="hs-identifier hs-type">Tense</span></a></span><span> </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><a href="Features.Nominal.html#NF"><span class="hs-identifier hs-type">NF</span></a></span><span> </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><a href="Features.Nominal.html#NF"><span class="hs-identifier hs-type">NF</span></a></span><span> </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><span class="hs-identifier hs-type">Either</span></span><span> </span><span class="annot"><a href="EuskeraAppError.html#EuskeraAppError"><span class="hs-identifier hs-type">EuskeraAppError</span></a></span><span> </span><span class="annot"><a href="Morphology.Utils.html#InflectedWord"><span class="hs-identifier hs-type">InflectedWord</span></a></span><span>
</span><span id="line-91"></span><span id="norNorkAux"><span class="annot"><span class="annottext">norNorkAux :: Tense -&gt; NF -&gt; NF -&gt; Either EuskeraAppError InflectedWord
</span><a href="Morphology.Verbal.html#norNorkAux"><span class="hs-identifier hs-var hs-var">norNorkAux</span></a></span></span><span> </span><span id="local-6989586621679082141"><span class="annot"><span class="annottext">Tense
</span><a href="#local-6989586621679082141"><span class="hs-identifier hs-var">tense</span></a></span></span><span> </span><span id="local-6989586621679082140"><span class="annot"><span class="annottext">NF
</span><a href="#local-6989586621679082140"><span class="hs-identifier hs-var">nork</span></a></span></span><span> </span><span id="local-6989586621679082139"><span class="annot"><span class="annottext">NF
</span><a href="#local-6989586621679082139"><span class="hs-identifier hs-var">nor</span></a></span></span><span> </span><span class="hs-glyph">=</span><span>
</span><span id="line-92"></span><span>  </span><span class="hs-keyword">case</span><span> </span><span class="annot"><span class="annottext">Tense
</span><a href="#local-6989586621679082141"><span class="hs-identifier hs-var">tense</span></a></span><span> </span><span class="hs-keyword">of</span><span>
</span><span id="line-93"></span><span>    </span><span class="annot"><span class="annottext">Tense
</span><a href="Features.Verbal.html#Present"><span class="hs-identifier hs-var">Present</span></a></span><span> </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><span class="annottext">InflectedWord -&gt; Either EuskeraAppError InflectedWord
forall a b. b -&gt; Either a b
</span><span class="hs-identifier hs-var">Right</span></span><span> </span><span class="annot"><span class="annottext">(InflectedWord -&gt; Either EuskeraAppError InflectedWord)
-&gt; InflectedWord -&gt; Either EuskeraAppError InflectedWord
forall a b. (a -&gt; b) -&gt; a -&gt; b
</span><span class="hs-operator hs-var">$</span></span><span> </span><span class="annot"><span class="annottext">(Person, Number) -&gt; (Person, Number) -&gt; InflectedWord
</span><a href="Morphology.IrregularVerbs.html#ukanPresent"><span class="hs-identifier hs-var">ukanPresent</span></a></span><span> </span><span class="annot"><span class="annottext">(Person, Number)
</span><a href="#local-6989586621679082137"><span class="hs-identifier hs-var">norkF</span></a></span><span> </span><span class="annot"><span class="annottext">(Person, Number)
</span><a href="#local-6989586621679082136"><span class="hs-identifier hs-var">norF</span></a></span><span>
</span><span id="line-94"></span><span>    </span><span class="annot"><span class="annottext">Tense
</span><a href="Features.Verbal.html#Past"><span class="hs-identifier hs-var">Past</span></a></span><span> </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><span class="annottext">InflectedWord -&gt; Either EuskeraAppError InflectedWord
forall a b. b -&gt; Either a b
</span><span class="hs-identifier hs-var">Right</span></span><span> </span><span class="annot"><span class="annottext">(InflectedWord -&gt; Either EuskeraAppError InflectedWord)
-&gt; InflectedWord -&gt; Either EuskeraAppError InflectedWord
forall a b. (a -&gt; b) -&gt; a -&gt; b
</span><span class="hs-operator hs-var">$</span></span><span> </span><span class="annot"><span class="annottext">(Person, Number) -&gt; (Person, Number) -&gt; InflectedWord
</span><a href="Morphology.IrregularVerbs.html#ukanPast"><span class="hs-identifier hs-var">ukanPast</span></a></span><span> </span><span class="annot"><span class="annottext">(Person, Number)
</span><a href="#local-6989586621679082137"><span class="hs-identifier hs-var">norkF</span></a></span><span> </span><span class="annot"><span class="annottext">(Person, Number)
</span><a href="#local-6989586621679082136"><span class="hs-identifier hs-var">norF</span></a></span><span>
</span><span id="line-95"></span><span>  </span><span class="hs-keyword">where</span><span>
</span><span id="line-96"></span><span>    </span><span id="local-6989586621679082137"><span class="annot"><span class="annottext">norkF :: (Person, Number)
</span><a href="#local-6989586621679082137"><span class="hs-identifier hs-var hs-var">norkF</span></a></span></span><span> </span><span class="hs-glyph">=</span><span> </span><span class="annot"><span class="annottext">NF -&gt; (Person, Number)
</span><a href="Features.Nominal.html#personNumber"><span class="hs-identifier hs-var">personNumber</span></a></span><span> </span><span class="annot"><span class="annottext">NF
</span><a href="#local-6989586621679082140"><span class="hs-identifier hs-var">nork</span></a></span><span>
</span><span id="line-97"></span><span>    </span><span id="local-6989586621679082136"><span class="annot"><span class="annottext">norF :: (Person, Number)
</span><a href="#local-6989586621679082136"><span class="hs-identifier hs-var hs-var">norF</span></a></span></span><span> </span><span class="hs-glyph">=</span><span> </span><span class="annot"><span class="annottext">NF -&gt; (Person, Number)
</span><a href="Features.Nominal.html#personNumber"><span class="hs-identifier hs-var">personNumber</span></a></span><span> </span><span class="annot"><span class="annottext">NF
</span><a href="#local-6989586621679082139"><span class="hs-identifier hs-var">nor</span></a></span><span>
</span><span id="line-98"></span><span>
</span><span id="line-99"></span><span class="hs-comment">--------------------------------------------------------------------------------</span><span>
</span><span id="line-100"></span><span class="hs-comment">-- Irregular verb inflection</span><span>
</span><span id="line-101"></span><span class="hs-comment">--------------------------------------------------------------------------------</span><span>
</span><span id="line-102"></span><span class="annot"><a href="Morphology.Verbal.html#inflectIrregularVerbs"><span class="hs-identifier hs-type">inflectIrregularVerbs</span></a></span><span> </span><span class="hs-glyph">::</span><span> </span><span class="annot"><a href="Features.Verbal.html#VF"><span class="hs-identifier hs-type">VF</span></a></span><span> </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><a href="Lexis.Verb.html#Verb"><span class="hs-identifier hs-type">Verb</span></a></span><span> </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><span class="hs-identifier hs-type">Either</span></span><span> </span><span class="annot"><a href="EuskeraAppError.html#EuskeraAppError"><span class="hs-identifier hs-type">EuskeraAppError</span></a></span><span> </span><span class="annot"><a href="Morphology.Utils.html#InflectedWord"><span class="hs-identifier hs-type">InflectedWord</span></a></span><span>
</span><span id="line-103"></span><span id="inflectIrregularVerbs"><span class="annot"><span class="annottext">inflectIrregularVerbs :: VF -&gt; Verb -&gt; Either EuskeraAppError InflectedWord
</span><a href="Morphology.Verbal.html#inflectIrregularVerbs"><span class="hs-identifier hs-var hs-var">inflectIrregularVerbs</span></a></span></span><span> </span><span id="local-6989586621679082133"><span class="annot"><span class="annottext">VF
</span><a href="#local-6989586621679082133"><span class="hs-identifier hs-var">vf</span></a></span></span><span> </span><span class="hs-special">(</span><span class="annot"><a href="Lexis.Verb.html#Nor"><span class="hs-identifier hs-type">Nor</span></a></span><span> </span><span class="annot"><span class="annottext">InflectedWord
</span><span class="hs-string">&quot;izan&quot;</span></span><span class="hs-special">)</span><span> </span><span class="hs-glyph">=</span><span> </span><span class="annot"><span class="annottext">InflectedWord -&gt; Either EuskeraAppError InflectedWord
forall a b. b -&gt; Either a b
</span><span class="hs-identifier hs-var">Right</span></span><span> </span><span class="annot"><span class="annottext">(InflectedWord -&gt; Either EuskeraAppError InflectedWord)
-&gt; InflectedWord -&gt; Either EuskeraAppError InflectedWord
forall a b. (a -&gt; b) -&gt; a -&gt; b
</span><span class="hs-operator hs-var">$</span></span><span> </span><span class="annot"><span class="annottext">Tense -&gt; NF -&gt; InflectedWord
</span><a href="Morphology.IrregularVerbs.html#inflectIzan"><span class="hs-identifier hs-var">inflectIzan</span></a></span><span> </span><span class="hs-special">(</span><span class="annot"><span class="annottext">VF -&gt; Tense
</span><a href="Features.Verbal.html#tense"><span class="hs-identifier hs-var hs-var">tense</span></a></span><span> </span><span class="annot"><span class="annottext">VF
</span><a href="#local-6989586621679082133"><span class="hs-identifier hs-var">vf</span></a></span><span class="hs-special">)</span><span> </span><span class="hs-special">(</span><span class="annot"><span class="annottext">VF -&gt; NF
</span><a href="Features.Verbal.html#nor"><span class="hs-identifier hs-var hs-var">nor</span></a></span><span> </span><span class="annot"><span class="annottext">VF
</span><a href="#local-6989586621679082133"><span class="hs-identifier hs-var">vf</span></a></span><span class="hs-special">)</span><span>
</span><span id="line-104"></span><span class="annot"><a href="Morphology.Verbal.html#inflectIrregularVerbs"><span class="hs-identifier hs-var">inflectIrregularVerbs</span></a></span><span> </span><span id="local-6989586621679082131"><span class="annot"><span class="annottext">VF
</span><a href="#local-6989586621679082131"><span class="hs-identifier hs-var">vf</span></a></span></span><span> </span><span class="hs-special">(</span><span class="annot"><a href="Lexis.Verb.html#Copula"><span class="hs-identifier hs-type">Copula</span></a></span><span> </span><span class="annot"><span class="annottext">InflectedWord
</span><span class="hs-string">&quot;izan&quot;</span></span><span class="hs-special">)</span><span> </span><span class="hs-glyph">=</span><span> </span><span class="annot"><span class="annottext">InflectedWord -&gt; Either EuskeraAppError InflectedWord
forall a b. b -&gt; Either a b
</span><span class="hs-identifier hs-var">Right</span></span><span> </span><span class="annot"><span class="annottext">(InflectedWord -&gt; Either EuskeraAppError InflectedWord)
-&gt; InflectedWord -&gt; Either EuskeraAppError InflectedWord
forall a b. (a -&gt; b) -&gt; a -&gt; b
</span><span class="hs-operator hs-var">$</span></span><span> </span><span class="annot"><span class="annottext">Tense -&gt; NF -&gt; InflectedWord
</span><a href="Morphology.IrregularVerbs.html#inflectIzan"><span class="hs-identifier hs-var">inflectIzan</span></a></span><span> </span><span class="hs-special">(</span><span class="annot"><span class="annottext">VF -&gt; Tense
</span><a href="Features.Verbal.html#tense"><span class="hs-identifier hs-var hs-var">tense</span></a></span><span> </span><span class="annot"><span class="annottext">VF
</span><a href="#local-6989586621679082131"><span class="hs-identifier hs-var">vf</span></a></span><span class="hs-special">)</span><span> </span><span class="hs-special">(</span><span class="annot"><span class="annottext">VF -&gt; NF
</span><a href="Features.Verbal.html#nor"><span class="hs-identifier hs-var hs-var">nor</span></a></span><span> </span><span class="annot"><span class="annottext">VF
</span><a href="#local-6989586621679082131"><span class="hs-identifier hs-var">vf</span></a></span><span class="hs-special">)</span><span>
</span><span id="line-105"></span><span class="annot"><a href="Morphology.Verbal.html#inflectIrregularVerbs"><span class="hs-identifier hs-var">inflectIrregularVerbs</span></a></span><span> </span><span id="local-6989586621679082130"><span class="annot"><span class="annottext">VF
</span><a href="#local-6989586621679082130"><span class="hs-identifier hs-var">vf</span></a></span></span><span> </span><span class="hs-special">(</span><span class="annot"><a href="Lexis.Verb.html#NorNork"><span class="hs-identifier hs-type">NorNork</span></a></span><span> </span><span class="annot"><span class="annottext">InflectedWord
</span><span class="hs-string">&quot;ukan&quot;</span></span><span class="hs-special">)</span><span> </span><span class="hs-glyph">=</span><span>
</span><span id="line-106"></span><span>  </span><span class="annot"><span class="annottext">Tense
-&gt; (Person, Number)
-&gt; (Person, Number)
-&gt; Either EuskeraAppError InflectedWord
</span><a href="Morphology.IrregularVerbs.html#inflectUkan"><span class="hs-identifier hs-var">inflectUkan</span></a></span><span> </span><span class="hs-special">(</span><span class="annot"><span class="annottext">VF -&gt; Tense
</span><a href="Features.Verbal.html#tense"><span class="hs-identifier hs-var hs-var">tense</span></a></span><span> </span><span class="annot"><span class="annottext">VF
</span><a href="#local-6989586621679082130"><span class="hs-identifier hs-var">vf</span></a></span><span class="hs-special">)</span><span> </span><span class="hs-special">(</span><span class="annot"><span class="annottext">NF -&gt; (Person, Number)
</span><a href="Features.Nominal.html#personNumber"><span class="hs-identifier hs-var">personNumber</span></a></span><span> </span><span class="annot"><span class="annottext">(NF -&gt; (Person, Number)) -&gt; NF -&gt; (Person, Number)
forall a b. (a -&gt; b) -&gt; a -&gt; b
</span><span class="hs-operator hs-var">$</span></span><span> </span><span class="annot"><span class="annottext">VF -&gt; NF
</span><a href="Features.Verbal.html#nork"><span class="hs-identifier hs-var hs-var">nork</span></a></span><span> </span><span class="annot"><span class="annottext">VF
</span><a href="#local-6989586621679082130"><span class="hs-identifier hs-var">vf</span></a></span><span class="hs-special">)</span><span> </span><span class="hs-special">(</span><span class="annot"><span class="annottext">NF -&gt; (Person, Number)
</span><a href="Features.Nominal.html#personNumber"><span class="hs-identifier hs-var">personNumber</span></a></span><span> </span><span class="annot"><span class="annottext">(NF -&gt; (Person, Number)) -&gt; NF -&gt; (Person, Number)
forall a b. (a -&gt; b) -&gt; a -&gt; b
</span><span class="hs-operator hs-var">$</span></span><span> </span><span class="annot"><span class="annottext">VF -&gt; NF
</span><a href="Features.Verbal.html#nor"><span class="hs-identifier hs-var hs-var">nor</span></a></span><span> </span><span class="annot"><span class="annottext">VF
</span><a href="#local-6989586621679082130"><span class="hs-identifier hs-var">vf</span></a></span><span class="hs-special">)</span><span>
</span><span id="line-107"></span><span class="annot"><a href="Morphology.Verbal.html#inflectIrregularVerbs"><span class="hs-identifier hs-var">inflectIrregularVerbs</span></a></span><span> </span><span class="annot"><span class="annottext">VF
</span><span class="hs-identifier">_</span></span><span> </span><span class="annot"><span class="annottext">Verb
</span><span class="hs-identifier">_</span></span><span> </span><span class="hs-glyph">=</span><span> </span><span class="annot"><span class="annottext">EuskeraAppError -&gt; Either EuskeraAppError InflectedWord
forall a b. a -&gt; Either a b
</span><span class="hs-identifier hs-var">Left</span></span><span> </span><span class="annot"><span class="annottext">EuskeraAppError
</span><a href="EuskeraAppError.html#Unimplemented"><span class="hs-identifier hs-var">Unimplemented</span></a></span><span>
</span><span id="line-108"></span><span>
</span><span id="line-109"></span><span class="hs-comment">-- https://www.hiru.eus/es/lengua-vasca/aspecto-tiempo-y-modo</span><span>
</span><span id="line-110"></span></pre></body></html>